<template>
  <SStatusMessage v-if="errorMessage.length" title="Log in unsuccessful" variant="error">
    Error: {{ errorMessage }}
  </SStatusMessage>
  <div class="flex items-center justify-center p-12">
    <div class="w-full max-w-sm rounded-lg bg-white p-6 shadow-md">
      <h2 class="mb-6 text-center text-3xl font-bold text-ec-primary-100">Login</h2>
      <form @submit.prevent="performLogin">
        <div class="mb-4 flex flex-col gap-y-3">
          <SInput
            v-model="username"
            label="Username"
            type="text"
            name="username"
            id="username"
            autocomplete="username"
            required
          />
          <SInput
            v-model="password"
            label="Password"
            type="password"
            name="password"
            autocomplete="current-password"
            id="current-password"
            required
          />
        </div>
        <div class="flex items-center justify-between">
          <SButton @submit.prevent="performLogin" @click="performLogin" type="submit"
            >Sign In</SButton
          >
        </div>
      </form>
    </div>
  </div>
</template>

<script setup lang="ts">
import SButton from '../common/SButton.vue';
import SInput from '../common/SInput.vue';
import SStatusMessage from '../common/SStatusMessage.vue';
import { ref } from 'vue';

const username = ref('');
const password = ref('');
const errorMessage = ref('');

const props = defineProps({
  redirectURL: {
    type: String,
    default: '/upload'
  }
})

const performLogin = async () => {
  errorMessage.value = '';

  const response = await fetch('/authorize', {
    method: 'POST',
    body: JSON.stringify({
      username: username.value,
      password: password.value,
    }),
    headers: new Headers({
      'Content-Type': 'application/json',
    }),
  });

  const data = await response.json();

  if (response.status === 200) {
    window.localStorage.setItem('KEYCLOAK_ACCESS_TOKEN', data.access_token);
    window.localStorage.setItem('KEYCLOAK_REFRESH_TOKEN', data.refresh_token);
    window.location.href = props.redirectURL;
  }

  if (data?.error_description) {
    errorMessage.value = data.error_description;
  }
};
</script>
